﻿SystemOrganization addCategory: #'Mongost-BSON'!

Object subclass: #MgBSON
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mongost-BSON'!

!MgBSON commentStamp: 'guest 2/12/2010 01:38' prior: 0!
<smalltalkDoc xmlns="http://www.stic.org/smalltalkDoc/">
<comment></comment>
</smalltalkDoc>!

!MgBSON class methodsFor: 'codec' stamp: 'mu 4/15/2011 21:38'!
read: aStream
	| reader |
	reader := MgLittleEndianStream on: aStream.
	^(self new setStream: reader) nextDictionary! !

!MgBSON class methodsFor: 'codec' stamp: 'guest 2/7/2010 19:08'!
write: aDictionary 
	^self writer 
		nextDictionaryPut: aDictionary; 
		contents! !

!MgBSON class methodsFor: 'codec' stamp: 'guest 2/7/2010 19:08'!
writeAll: aCollection 
	| writer |
	writer := self writer.
	aCollection do: [:each | writer nextDictionaryPut: each].
	^writer contents! !

!MgBSON class methodsFor: 'instance creation' stamp: 'mu 4/15/2011 21:38'!
writer
	^self new setStream: (MgLittleEndianStream on: ByteArray new writeStream)! !

!MgBSON methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
addObjectType: anInteger to: aDictionary
	| key value readSelectors |
	key := self nextKey.
	readSelectors := Dictionary new.
	readSelectors at: 2 put: #nextSizedString.
	readSelectors at: 3 put: #nextDictionary.
	readSelectors at: 9 put: #nextTimestamp.
	readSelectors at: 8 put: #nextBoolean.
	readSelectors at: 4 put: #nextArray.
	readSelectors at: 1 put: #nextDouble.
	readSelectors at: 10 put: #nextNil.
	readSelectors at: 14 put: #nextSymbol.
	readSelectors at: 7 put: #nextOID.
	readSelectors at: 6 put: #nextUndefined.
	readSelectors at: 16 put: #nextInt32.
	readSelectors at: 18 put: #nextInt64.
	value := self perform: (readSelectors at: anInteger ifAbsent: [self error: 'Unknown type code: ' , anInteger printString]).
	aDictionary at: key put: value! !

!MgBSON methodsFor: 'accessing' stamp: 'guest 2/7/2010 19:08'!
contents
	^stream contents! !

!MgBSON methodsFor: 'accessing' stamp: 'KentBeck 2/9/2010 16:30'!
epoch
	^DateAndTime year: 1970 day: 1! !

!MgBSON methodsFor: 'testing' stamp: 'guest 2/7/2010 19:08'!
isInt32: anInteger
	^anInteger between: (2 raisedTo: 31) negated and: (2 raisedTo: 31) - 1! !

!MgBSON methodsFor: 'testing' stamp: 'guest 2/7/2010 19:08'!
isInt64: anInteger
	^anInteger between: (2 raisedTo: 63) negated and: (2 raisedTo: 63) - 1! !

!MgBSON methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
nextArray
	| elements results |
	elements := self nextDictionary.
	results := Array new: elements size.
	elements keysAndValuesDo: 
		[:eachKey :eachValue || index | 
		index := (Integer readFrom: eachKey readStream) + 1. 
		results at: index put: eachValue].
	^results! !

!MgBSON methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
nextArrayPut: anArray
	| elements start end |
	elements := Dictionary new.
	anArray
		keysAndValuesDo: [:eachKey :eachValue | elements at: (eachKey - 1) printString put: eachValue].
	start := stream position.
	stream nextInt32Put: 0.	"Just to make space"
	elements associations do: [:each | each writeBSONOn: self].
	stream null.
	end := stream position.
	stream position: start.
	stream nextInt32Put: end - start.
	stream position: end! !

!MgBSON methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
nextAssociationPut: anAssociation 
	stream nextBytePut: (self typeCode: anAssociation value).
	self nextStringPut: anAssociation key.
	anAssociation value writeBSONOn: self! !

!MgBSON methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
nextBoolean
	^stream nextByte = 1! !

!MgBSON methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
nextBooleanPut: aBoolean
	stream nextBytePut: (aBoolean ifTrue: [1] ifFalse: [0])! !

!MgBSON methodsFor: 'reading' stamp: 'KentBeck 2/9/2010 17:01'!
nextDictionary
	| result byteSize start end |
	result := Dictionary new.
	byteSize := stream nextUInt32.
	[| type |
	type := stream nextByte.
	type = 0 ifTrue: [^result].
	self addObjectType: type to: result]
		repeat.
	^self error: 'Attempt to read off end of stream'! !

!MgBSON methodsFor: 'writing' stamp: 'KentBeck 2/12/2010 18:01'!
nextDictionaryPut: aDictionary
	| start end |
	start := stream position.
	stream nextInt32Put: 0.	"Just to make space"
	(aDictionary associations asSortedCollection: [:a :b | a key = '_id' | (a key < b key)]) do: [:each | each writeBSONOn: self].
	stream null.
	end := stream position.
	stream position: start.
	stream nextInt32Put: end - start.
	stream position: end! !

!MgBSON methodsFor: 'reading' stamp: 'mu 6/21/2011 15:04'!
nextDouble
	^MgPortableUtil default readDoubleFrom: stream! !

!MgBSON methodsFor: 'writing' stamp: 'mu 6/21/2011 15:04'!
nextDoublePut: aDouble 
	stream nextBytesPut: (MgPortableUtil default doubleToBytes: aDouble)! !

!MgBSON methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
nextInt32
	^stream nextInt32! !

!MgBSON methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
nextInt64
	^stream nextInt64! !

!MgBSON methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
nextIntegerPut: anInteger
	"Seems like this belongs here instead of the caller or the stream, but not certain"

	(self isInt32: anInteger) ifTrue: [^stream nextInt32Put: anInteger].
	(self isInt64: anInteger) ifTrue: [^stream nextInt64Put: anInteger].
	self error: 'Integer too large: ' , anInteger printString! !

!MgBSON methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
nextKey
	^stream nextString! !

!MgBSON methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
nextNil
	^nil! !

!MgBSON methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
nextNilPut
	"This method intentionally if reluctantly left blank"! !

!MgBSON methodsFor: 'reading' stamp: 'mu 6/21/2011 15:04'!
nextOID
	| value |
	value := LargePositiveInteger basicNew: 12.
	1 to: 12 do: [:each | value basicAt: each put: stream nextByte].
	^MgOID value: (MgPortableUtil default compressLargeInteger: value)! !

!MgBSON methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
nextOIDPut: anOID 
	| value |
	value := anOID value.
	12 timesRepeat: 
		[stream nextBytePut: (value bitAnd: 16rFF). 
		value := value bitShift: -8]! !

!MgBSON methodsFor: 'reading' stamp: 'KentBeck 2/9/2010 17:02'!
nextSizedString
	| size result start |
	size := stream nextUInt32.
	^stream nextString "maybe stream decode: (stream next: size) instead"! !

!MgBSON methodsFor: 'writing' stamp: 'mu 4/18/2011 17:12'!
nextSizedStringPut: aString
	| encoded |
	encoded := stream encode: aString.
	stream nextInt32Put: encoded size + 1.	"For terminating null"
	stream nextBytesPut: encoded.
	stream null! !

!MgBSON methodsFor: 'writing' stamp: 'KentBeck 2/9/2010 14:39'!
nextStringPut: aByteString
	stream nextStringPut: aByteString! !

!MgBSON methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
nextSymbol
	^self nextSizedString asSymbol! !

!MgBSON methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
nextSymbolPut: aByteSymbol 
	self nextSizedStringPut: aByteSymbol! !

!MgBSON methodsFor: 'reading' stamp: 'mu 6/21/2011 15:04'!
nextTimestamp
	^MgPortableUtil default intToTime: stream nextInt64! !

!MgBSON methodsFor: 'writing' stamp: 'mu 6/21/2011 15:04'!
nextTimestampPut: aTimestamp 
	stream nextInt64Put: (MgPortableUtil default timeToMilliseconds: aTimestamp)! !

!MgBSON methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
nextUndefined
	"Not sure what I should reply here"
	^nil! !

!MgBSON methodsFor: 'private' stamp: 'guest 2/7/2010 19:08'!
setStream: aStream
	stream := aStream! !

!MgBSON methodsFor: 'accessing' stamp: 'KentBeck 2/11/2010 17:58'!
typeCode: anObject
	^anObject bsonTypeCode! !

Object subclass: #MgLittleEndianStream
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mongost-BSON'!

!MgLittleEndianStream commentStamp: 'guest 2/12/2010 01:38' prior: 0!
<smalltalkDoc xmlns="http://www.stic.org/smalltalkDoc/">
<comment></comment>
</smalltalkDoc>!

!MgLittleEndianStream class methodsFor: 'instance creation' stamp: 'guest 2/7/2010 19:08'!
on: aReadStream 
	^self new setReader: aReadStream! !

!MgLittleEndianStream methodsFor: 'accessing' stamp: 'guest 2/7/2010 19:08'!
contents
	^stream contents! !

!MgLittleEndianStream methodsFor: 'writing' stamp: 'mu 6/21/2011 15:04'!
encode: aString
	^MgPortableUtil default bytesFromString: aString! !

!MgLittleEndianStream methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
flush
	stream flush! !

!MgLittleEndianStream methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
nextByte
	"Worry about sign? What sayeth the spec?"

	^stream next! !

!MgLittleEndianStream methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
nextBytePut: anInteger 
	stream nextPut: anInteger! !

!MgLittleEndianStream methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
nextBytesPut: aByteArray 
	stream nextPutAll: aByteArray! !

!MgLittleEndianStream methodsFor: 'writing' stamp: 'KentBeck 2/9/2010 14:40'!
nextEncodedStringPut: aByteArray 
	self 
		nextBytesPut: aByteArray;
		null! !

!MgLittleEndianStream methodsFor: 'reading' stamp: 'KentBeck 2/9/2010 16:59'!
nextInt32
	| unsigned |
	unsigned := self nextUInt32.
	^unsigned <= ((2 raisedTo: 31) - 1)
		ifTrue: [unsigned]
		ifFalse: [((2 raisedTo: 32) - unsigned) negated]! !

!MgLittleEndianStream methodsFor: 'writing' stamp: 'guest 2/8/2010 22:12'!
nextInt32Put: anInteger 
	self nextBytePut: (anInteger bitAnd: 16rFF).
	self nextBytePut: ((anInteger bitShift: -8) bitAnd: 16rFF).
	self nextBytePut: ((anInteger bitShift: -16) bitAnd: 16rFF).
	self nextBytePut: ((anInteger bitShift: -24) bitAnd: 16rFF)! !

!MgLittleEndianStream methodsFor: 'reading' stamp: 'guest 2/7/2010 19:08'!
nextInt64
	| unsigned |
	unsigned := stream next + (stream next bitShift: 8) + (stream next bitShift: 16) + (stream next bitShift: 24) + (stream next bitShift: 32) + (stream next bitShift: 40) + (stream next bitShift: 48) + (stream next bitShift: 56).
	^unsigned <= ((2 raisedTo: 63) - 1)
		ifTrue: [unsigned]
		ifFalse: [((2 raisedTo: 64) - unsigned) negated]! !

!MgLittleEndianStream methodsFor: 'writing' stamp: 'guest 2/8/2010 22:12'!
nextInt64Put: anInteger 
	self nextBytePut: (anInteger bitAnd: 16rFF).
	self nextBytePut: ((anInteger bitShift: -8) bitAnd: 16rFF).
	self nextBytePut: ((anInteger bitShift: -16) bitAnd: 16rFF).
	self nextBytePut: ((anInteger bitShift: -24) bitAnd: 16rFF).
	self nextBytePut: ((anInteger bitShift: -32) bitAnd: 16rFF).
	self nextBytePut: ((anInteger bitShift: -40) bitAnd: 16rFF).
	self nextBytePut: ((anInteger bitShift: -48) bitAnd: 16rFF).
	self nextBytePut: ((anInteger bitShift: -56) bitAnd: 16rFF)! !

!MgLittleEndianStream methodsFor: 'writing' stamp: 'KentBeck 2/9/2010 16:44'!
nextSizedStringPut: aString
	| encoded |
	encoded := self encode: aString.
	self nextInt32Put: encoded size + 1.	"For terminating null"
	self nextEncodedStringPut: encoded! !

!MgLittleEndianStream methodsFor: 'reading' stamp: 'mu 6/21/2011 15:05'!
nextString
	| bytes |
	bytes := stream upTo: 0.
	bytes size = 0 ifTrue: [self error]. "Needed?"
	^ MgPortableUtil default stringFromBytes: bytes.
	
	! !

!MgLittleEndianStream methodsFor: 'writing' stamp: 'KentBeck 2/9/2010 16:50'!
nextStringPut: aString 
	| encoder writer encoded |
"	encoder := UTF8StreamEncoder new.
	aString do: [:each | encoder nextPut: each on: stream]."
	encoded := self encode: aString.
	self nextEncodedStringPut: encoded ! !

!MgLittleEndianStream methodsFor: 'reading' stamp: 'KentBeck 2/9/2010 16:59'!
nextUInt32
	| unsigned |
	^stream next + (stream next bitShift: 8) + (stream next bitShift: 16) + (stream next bitShift: 24)! !

!MgLittleEndianStream methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
null
	self nextBytePut: 0! !

!MgLittleEndianStream methodsFor: 'accessing' stamp: 'guest 2/7/2010 19:08'!
position
	^stream position! !

!MgLittleEndianStream methodsFor: 'accessing' stamp: 'guest 2/7/2010 19:08'!
position: anInteger 
	stream position: anInteger! !

!MgLittleEndianStream methodsFor: 'private' stamp: 'guest 2/7/2010 19:08'!
setReader: aReadStream 
	stream := aReadStream! !

Object subclass: #MgOID
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mongost-BSON'!

!MgOID commentStamp: 'guest 2/12/2010 01:38' prior: 0!
<smalltalkDoc xmlns="http://www.stic.org/smalltalkDoc/">
<comment></comment>
</smalltalkDoc>!

!MgOID class methodsFor: 'instance creation' stamp: 'guest 2/7/2010 19:08'!
value: anInteger 
	^self new setValue: anInteger! !

!MgOID methodsFor: 'comparing' stamp: 'guest 2/7/2010 19:08'!
= anObject
	^anObject class = self class and: [anObject value = self value]! !

!MgOID methodsFor: 'accessing' stamp: 'KentBeck 2/11/2010 18:08'!
bsonTypeCode
	^7! !

!MgOID methodsFor: 'comparing' stamp: 'guest 2/7/2010 19:08'!
hash
	^value hash! !

!MgOID methodsFor: 'printing' stamp: 'mu 4/18/2011 17:09'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPutAll: '('.
	self value printOn: aStream.
	aStream nextPutAll: ')'.! !

!MgOID methodsFor: 'private' stamp: 'guest 2/7/2010 19:08'!
setValue: anInteger 
	value := anInteger! !

!MgOID methodsFor: 'accessing' stamp: 'guest 2/7/2010 19:08'!
value
	^value! !

!MgOID methodsFor: 'writing' stamp: 'guest 2/7/2010 19:08'!
writeBSONOn: aBSON 
	aBSON nextOIDPut: self! !

!Dictionary methodsFor: '*Mongost-BSON' stamp: 'KentBeck 2/11/2010 18:10'!
bsonTypeCode
	^3! !

!Dictionary methodsFor: '*Mongost-BSON' stamp: 'guest 2/12/2010 01:38'!
writeBSONOn: aBSON 
	aBSON nextDictionaryPut: self! !

!UndefinedObject methodsFor: '*Mongost-BSON' stamp: 'KentBeck 2/11/2010 18:11'!
bsonTypeCode
	^10! !

!UndefinedObject methodsFor: '*Mongost-BSON' stamp: 'guest 2/12/2010 01:38'!
writeBSONOn: aBSON 
	aBSON nextNilPut! !

!Association methodsFor: '*Mongost-BSON' stamp: 'guest 2/12/2010 01:38'!
writeBSONOn: aBSON 
	aBSON nextAssociationPut: self! !

!Boolean methodsFor: '*Mongost-BSON' stamp: 'KentBeck 2/11/2010 18:09'!
bsonTypeCode
	^8! !

!Boolean methodsFor: '*Mongost-BSON' stamp: 'guest 2/12/2010 01:38'!
writeBSONOn: aBSON 
	aBSON nextBooleanPut: self! !

!Float methodsFor: '*Mongost-BSON' stamp: 'KentBeck 2/11/2010 17:59'!
bsonTypeCode
	^1! !

!Float methodsFor: '*Mongost-BSON' stamp: 'KentBeck 2/11/2010 18:00'!
writeBSONOn: aBSON 
	aBSON nextDoublePut: self! !

!SequenceableCollection methodsFor: '*Mongost-BSON' stamp: 'KentBeck 2/11/2010 18:11'!
bsonTypeCode
	^4! !

!Array methodsFor: '*Mongost-BSON' stamp: 'guest 2/12/2010 01:38'!
writeBSONOn: aBSON 
	aBSON nextArrayPut: self! !

!Integer methodsFor: '*Mongost-BSON' stamp: 'mu 4/15/2011 21:34'!
bsonTypeCode
	(MgBSON new isInt32: self) ifTrue: [^16].
	(MgBSON new isInt64: self) ifTrue: [^18].
	self error: 'Integer too large: ' , self printString! !

!Integer methodsFor: '*Mongost-BSON' stamp: 'KentBeck 2/11/2010 21:46'!
writeBSONOn: aBSON
	aBSON nextIntegerPut: self! !

!String methodsFor: '*Mongost-BSON' stamp: 'KentBeck 2/11/2010 18:09'!
bsonTypeCode
	^2! !

!String methodsFor: '*Mongost-BSON' stamp: 'mu 4/18/2011 17:16'!
writeBSONOn: aBSON 
	aBSON nextSizedStringPut: self! !

!Symbol methodsFor: '*Mongost-BSON' stamp: 'guest 2/12/2010 19:37'!
bsonTypeCode
	^14! !

!Symbol methodsFor: '*Mongost-BSON' stamp: 'mu 4/18/2011 17:16'!
writeBSONOn: aBSON 
	aBSON nextSymbolPut: self! !
